/* client.c generated by valac 0.17.2, the Vala compiler
 * generated from client.vala, do not modify */

/*
 * Copyright (C) 2012 Daiki Ueno <ueno@unixuser.org>
 * Copyright (C) 2012 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <libfep-glib/libfep-glib.h>
#include <ibus.h>
#include <stdlib.h>
#include <gio/gio.h>


#define TYPE_PREEDIT_STYLE (preedit_style_get_type ())

#define TYPE_OPTIONS (options_get_type ())
typedef struct _Options Options;

#define TYPE_CLIENT (client_get_type ())
#define CLIENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CLIENT, Client))
#define CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CLIENT, ClientClass))
#define IS_CLIENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CLIENT))
#define IS_CLIENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CLIENT))
#define CLIENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CLIENT, ClientClass))

typedef struct _Client Client;
typedef struct _ClientClass ClientClass;
typedef struct _ClientPrivate ClientPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_io_channel_unref0(var) ((var == NULL) ? NULL : (var = (g_io_channel_unref (var), NULL)))

typedef enum  {
	PREEDIT_STYLE_OVER_THE_SPOT,
	PREEDIT_STYLE_ROOT,
	PREEDIT_STYLE_DEFAULT = PREEDIT_STYLE_OVER_THE_SPOT
} PreeditStyle;

struct _Options {
	PreeditStyle preedit_style;
};

struct _Client {
	FepGClient parent_instance;
	ClientPrivate * priv;
};

struct _ClientClass {
	FepGClientClass parent_class;
};

struct _ClientPrivate {
	IBusInputContext* context;
	IBusLookupTable* lookup_table;
	gboolean preedit_visible;
	gboolean lookup_table_visible;
	Options opts;
	gchar* preedit;
	FepGAttribute* preedit_attr;
	gchar* status;
	FepGAttribute* status_attr;
};

struct _Block1Data {
	int _ref_count_;
	Client * self;
	IBusBus* bus;
};


static gpointer client_parent_class = NULL;

GType preedit_style_get_type (void) G_GNUC_CONST;
GType options_get_type (void) G_GNUC_CONST;
Options* options_dup (const Options* self);
void options_free (Options* self);
GType client_get_type (void) G_GNUC_CONST;
#define CLIENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CLIENT, ClientPrivate))
enum  {
	CLIENT_DUMMY_PROPERTY
};
static void _client_ibus_commit_text (Client* self, IBusText* text);
static void _client_ibus_show_preedit_text (Client* self);
static FepGAttribute* _fep_gattribute_dup (FepGAttribute* self);
static void _client_ibus_hide_preedit_text (Client* self);
static void client_update_status (Client* self);
static void _client_ibus_update_preedit_text (Client* self, IBusText* text, guint cursor_pos, gboolean visible);
static gboolean _fep_gattribute_equal (const FepGAttribute* s1, const FepGAttribute* s2);
static gchar* client_format_indicator (Client* self);
static void _client_ibus_show_lookup_table (Client* self);
static void _client_ibus_hide_lookup_table (Client* self);
static void _client_ibus_update_lookup_table (Client* self, IBusLookupTable* lookup_table, gboolean visible);
static void _client_ibus_global_engine_changed (Client* self, const gchar* name);
static gboolean client_real_filter_key_event (FepGClient* base, guint keyval, guint modifiers);
static gboolean client_watch_func (Client* self, GIOChannel* source, GIOCondition condition);
static void client_create_input_context_done (Client* self);
static void __client_ibus_commit_text_ibus_input_context_commit_text (IBusInputContext* _sender, IBusText* p0, gpointer self);
static void __client_ibus_show_preedit_text_ibus_input_context_show_preedit_text (IBusInputContext* _sender, gpointer self);
static void __client_ibus_hide_preedit_text_ibus_input_context_hide_preedit_text (IBusInputContext* _sender, gpointer self);
static void __client_ibus_update_preedit_text_ibus_input_context_update_preedit_text (IBusInputContext* _sender, IBusText* p0, guint p1, gboolean p2, gpointer self);
static void __client_ibus_show_lookup_table_ibus_input_context_show_lookup_table (IBusInputContext* _sender, gpointer self);
static void __client_ibus_hide_lookup_table_ibus_input_context_hide_lookup_table (IBusInputContext* _sender, gpointer self);
static void __client_ibus_update_lookup_table_ibus_input_context_update_lookup_table (IBusInputContext* _sender, IBusLookupTable* p0, gboolean p1, gpointer self);
Client* client_new (IBusBus* bus, Options* opts, GError** error);
Client* client_construct (GType object_type, IBusBus* bus, Options* opts, GError** error);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __client_ibus_global_engine_changed_ibus_bus_global_engine_changed (IBusBus* _sender, const gchar* p0, gpointer self);
static void __lambda2_ (Block1Data* _data1_, GObject* obj, GAsyncResult* res);
static void ___lambda2__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static gboolean _client_watch_func_gio_func (GIOChannel* source, GIOCondition condition, gpointer self);
static void client_finalize (GObject* obj);


GType preedit_style_get_type (void) {
	static volatile gsize preedit_style_type_id__volatile = 0;
	if (g_once_init_enter (&preedit_style_type_id__volatile)) {
		static const GEnumValue values[] = {{PREEDIT_STYLE_OVER_THE_SPOT, "PREEDIT_STYLE_OVER_THE_SPOT", "over-the-spot"}, {PREEDIT_STYLE_ROOT, "PREEDIT_STYLE_ROOT", "root"}, {PREEDIT_STYLE_DEFAULT, "PREEDIT_STYLE_DEFAULT", "default"}, {0, NULL, NULL}};
		GType preedit_style_type_id;
		preedit_style_type_id = g_enum_register_static ("PreeditStyle", values);
		g_once_init_leave (&preedit_style_type_id__volatile, preedit_style_type_id);
	}
	return preedit_style_type_id__volatile;
}


Options* options_dup (const Options* self) {
	Options* dup;
	dup = g_new0 (Options, 1);
	memcpy (dup, self, sizeof (Options));
	return dup;
}


void options_free (Options* self) {
	g_free (self);
}


GType options_get_type (void) {
	static volatile gsize options_type_id__volatile = 0;
	if (g_once_init_enter (&options_type_id__volatile)) {
		GType options_type_id;
		options_type_id = g_boxed_type_register_static ("Options", (GBoxedCopyFunc) options_dup, (GBoxedFreeFunc) options_free);
		g_once_init_leave (&options_type_id__volatile, options_type_id);
	}
	return options_type_id__volatile;
}


static void _client_ibus_commit_text (Client* self, IBusText* text) {
	IBusText* _tmp0_;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* str;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = text;
	_tmp1_ = ibus_text_get_text (_tmp0_);
	_tmp2_ = g_strdup (_tmp1_);
	str = _tmp2_;
	_tmp3_ = str;
	_tmp4_ = strlen (_tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp5_ > 0) {
		const gchar* _tmp6_;
		_tmp6_ = str;
		fep_g_client_send_text ((FepGClient*) self, _tmp6_);
	}
	_g_free0 (str);
}


static FepGAttribute* _fep_gattribute_dup (FepGAttribute* self) {
	FepGAttribute* dup;
	dup = g_new0 (FepGAttribute, 1);
	memcpy (dup, self, sizeof (FepGAttribute));
	return dup;
}


static gpointer __fep_gattribute_dup0 (gpointer self) {
	return self ? _fep_gattribute_dup (self) : NULL;
}


static void _client_ibus_show_preedit_text (Client* self) {
	Options _tmp0_;
	PreeditStyle _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->opts;
	_tmp1_ = _tmp0_.preedit_style;
	if (_tmp1_ == PREEDIT_STYLE_ROOT) {
		const gchar* _tmp2_;
		FepGAttribute* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		FepGAttribute* _tmp6_;
		FepGAttribute* _tmp7_;
		_tmp2_ = self->priv->preedit;
		_tmp3_ = self->priv->preedit_attr;
		fep_g_client_set_status_text ((FepGClient*) self, _tmp2_, _tmp3_);
		_tmp4_ = self->priv->preedit;
		_tmp5_ = g_strdup (_tmp4_);
		_g_free0 (self->priv->status);
		self->priv->status = _tmp5_;
		_tmp6_ = self->priv->preedit_attr;
		_tmp7_ = __fep_gattribute_dup0 (_tmp6_);
		_g_free0 (self->priv->status_attr);
		self->priv->status_attr = _tmp7_;
	} else {
		const gchar* _tmp8_;
		FepGAttribute* _tmp9_;
		_tmp8_ = self->priv->preedit;
		_tmp9_ = self->priv->preedit_attr;
		fep_g_client_set_cursor_text ((FepGClient*) self, _tmp8_, _tmp9_);
	}
	self->priv->preedit_visible = TRUE;
}


static void _client_ibus_hide_preedit_text (Client* self) {
	Options _tmp0_;
	PreeditStyle _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->opts;
	_tmp1_ = _tmp0_.preedit_style;
	if (_tmp1_ == PREEDIT_STYLE_ROOT) {
		client_update_status (self);
	} else {
		fep_g_client_set_cursor_text ((FepGClient*) self, "", NULL);
	}
	self->priv->preedit_visible = FALSE;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gboolean _fep_gattribute_equal (const FepGAttribute* s1, const FepGAttribute* s2) {
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->type != s2->type) {
		return FALSE;
	}
	if (s1->value != s2->value) {
		return FALSE;
	}
	if (s1->start_index != s2->start_index) {
		return FALSE;
	}
	if (s1->end_index != s2->end_index) {
		return FALSE;
	}
	return TRUE;
}


static void _client_ibus_update_preedit_text (Client* self, IBusText* text, guint cursor_pos, gboolean visible) {
	IBusText* _tmp0_;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _preedit;
	IBusText* _tmp3_;
	IBusAttrList* _tmp4_ = NULL;
	IBusAttrList* _tmp5_;
	IBusAttrList* attrs;
	FepGAttribute* attr;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	gboolean _tmp31_;
	gboolean _tmp34_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	_tmp0_ = text;
	_tmp1_ = ibus_text_get_text (_tmp0_);
	_tmp2_ = g_strdup (_tmp1_);
	_preedit = _tmp2_;
	_tmp3_ = text;
	_tmp4_ = ibus_text_get_attributes (_tmp3_);
	_tmp5_ = _g_object_ref0 (_tmp4_);
	attrs = _tmp5_;
	attr = NULL;
	{
		gint i;
		i = 0;
		{
			gboolean _tmp6_;
			_tmp6_ = TRUE;
			while (TRUE) {
				gboolean _tmp7_;
				gint _tmp9_;
				IBusAttrList* _tmp10_;
				GArray* _tmp11_;
				guint _tmp12_;
				IBusAttrList* _tmp13_;
				gint _tmp14_;
				IBusAttribute* _tmp15_ = NULL;
				IBusAttribute* _tmp16_;
				IBusAttribute* _attr;
				IBusAttribute* _tmp17_;
				guint _tmp18_;
				_tmp7_ = _tmp6_;
				if (!_tmp7_) {
					gint _tmp8_;
					_tmp8_ = i;
					i = _tmp8_ + 1;
				}
				_tmp6_ = FALSE;
				_tmp9_ = i;
				_tmp10_ = attrs;
				_tmp11_ = _tmp10_->attributes;
				_tmp12_ = _tmp11_->len;
				if (!(((guint) _tmp9_) < _tmp12_)) {
					break;
				}
				_tmp13_ = attrs;
				_tmp14_ = i;
				_tmp15_ = ibus_attr_list_get (_tmp13_, (guint) _tmp14_);
				_tmp16_ = _g_object_ref0 (_tmp15_);
				_attr = _tmp16_;
				_tmp17_ = _attr;
				_tmp18_ = _tmp17_->type;
				if (_tmp18_ == ((guint) IBUS_ATTR_TYPE_UNDERLINE)) {
					IBusAttribute* _tmp19_;
					guint _tmp20_;
					IBusAttribute* _tmp21_;
					guint _tmp22_;
					FepGAttribute _tmp23_ = {0};
					FepGAttribute* _tmp24_;
					_tmp19_ = _attr;
					_tmp20_ = _tmp19_->start_index;
					_tmp21_ = _attr;
					_tmp22_ = _tmp21_->end_index;
					memset (&_tmp23_, 0, sizeof (FepGAttribute));
					_tmp23_.type = FEP_G_ATTR_TYPE_UNDERLINE;
					_tmp23_.value = (guint) FEP_G_ATTR_UNDERLINE_SINGLE;
					_tmp23_.start_index = _tmp20_;
					_tmp23_.end_index = _tmp22_;
					_tmp24_ = __fep_gattribute_dup0 (&_tmp23_);
					_g_free0 (attr);
					attr = _tmp24_;
				}
				_g_object_unref0 (_attr);
			}
		}
	}
	_tmp27_ = self->priv->preedit;
	_tmp28_ = _preedit;
	if (g_strcmp0 (_tmp27_, _tmp28_) != 0) {
		_tmp26_ = TRUE;
	} else {
		FepGAttribute* _tmp29_;
		FepGAttribute* _tmp30_;
		_tmp29_ = self->priv->preedit_attr;
		_tmp30_ = attr;
		_tmp26_ = _fep_gattribute_equal (_tmp29_, _tmp30_) != TRUE;
	}
	_tmp31_ = _tmp26_;
	if (_tmp31_) {
		_tmp25_ = TRUE;
	} else {
		gboolean _tmp32_;
		gboolean _tmp33_;
		_tmp32_ = self->priv->preedit_visible;
		_tmp33_ = visible;
		_tmp25_ = _tmp32_ != _tmp33_;
	}
	_tmp34_ = _tmp25_;
	if (_tmp34_) {
		const gchar* _tmp35_;
		gchar* _tmp36_;
		FepGAttribute* _tmp37_;
		FepGAttribute* _tmp38_;
		gboolean _tmp39_;
		_tmp35_ = _preedit;
		_tmp36_ = g_strdup (_tmp35_);
		_g_free0 (self->priv->preedit);
		self->priv->preedit = _tmp36_;
		_tmp37_ = attr;
		_tmp38_ = __fep_gattribute_dup0 (_tmp37_);
		_g_free0 (self->priv->preedit_attr);
		self->priv->preedit_attr = _tmp38_;
		_tmp39_ = visible;
		if (_tmp39_) {
			_client_ibus_show_preedit_text (self);
		} else {
			_client_ibus_hide_preedit_text (self);
		}
	}
	_g_free0 (attr);
	_g_object_unref0 (attrs);
	_g_free0 (_preedit);
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* end;
	gchar* _tmp3_;
	_tmp0_ = str;
	_tmp1_ = maxlen;
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
	end = _tmp2_;
	_tmp3_ = end;
	if (_tmp3_ == NULL) {
		glong _tmp4_;
		_tmp4_ = maxlen;
		result = _tmp4_;
		return result;
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = end;
		_tmp6_ = str;
		result = (glong) (_tmp5_ - _tmp6_);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	gboolean _tmp3_;
	glong _tmp9_;
	glong _tmp15_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	glong _tmp22_;
	gchar* _tmp23_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = offset;
	if (_tmp1_ >= ((glong) 0)) {
		glong _tmp2_;
		_tmp2_ = len;
		_tmp0_ = _tmp2_ >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	_tmp3_ = _tmp0_;
	if (_tmp3_) {
		glong _tmp4_;
		glong _tmp5_;
		glong _tmp6_ = 0L;
		_tmp4_ = offset;
		_tmp5_ = len;
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
		string_length = _tmp6_;
	} else {
		gint _tmp7_;
		gint _tmp8_;
		_tmp7_ = strlen (self);
		_tmp8_ = _tmp7_;
		string_length = (glong) _tmp8_;
	}
	_tmp9_ = offset;
	if (_tmp9_ < ((glong) 0)) {
		glong _tmp10_;
		glong _tmp11_;
		glong _tmp12_;
		_tmp10_ = string_length;
		_tmp11_ = offset;
		offset = _tmp10_ + _tmp11_;
		_tmp12_ = offset;
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
	} else {
		glong _tmp13_;
		glong _tmp14_;
		_tmp13_ = offset;
		_tmp14_ = string_length;
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
	}
	_tmp15_ = len;
	if (_tmp15_ < ((glong) 0)) {
		glong _tmp16_;
		glong _tmp17_;
		_tmp16_ = string_length;
		_tmp17_ = offset;
		len = _tmp16_ - _tmp17_;
	}
	_tmp18_ = offset;
	_tmp19_ = len;
	_tmp20_ = string_length;
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
	_tmp21_ = offset;
	_tmp22_ = len;
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
	result = _tmp23_;
	return result;
}


static gchar* client_format_indicator (Client* self) {
	gchar* result = NULL;
	IBusInputContext* _tmp0_;
	IBusEngineDesc* _tmp1_ = NULL;
	IBusEngineDesc* _tmp2_;
	IBusEngineDesc* desc;
	IBusEngineDesc* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->context;
	_tmp1_ = ibus_input_context_get_engine (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	desc = _tmp2_;
	_tmp3_ = desc;
	if (_tmp3_ != NULL) {
		IBusEngineDesc* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* symbol;
		const gchar* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		_tmp4_ = desc;
		_tmp5_ = ibus_engine_desc_get_symbol (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_strdup (_tmp6_);
		symbol = _tmp7_;
		_tmp8_ = symbol;
		_tmp9_ = strlen (_tmp8_);
		_tmp10_ = _tmp9_;
		if (_tmp10_ == 0) {
			IBusEngineDesc* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_ = NULL;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_ = NULL;
			_tmp11_ = desc;
			_tmp12_ = ibus_engine_desc_get_name (_tmp11_);
			_tmp13_ = _tmp12_;
			_tmp14_ = g_utf8_strup (_tmp13_, (gssize) (-1));
			_tmp15_ = _tmp14_;
			_tmp16_ = g_strconcat (_tmp15_, "??", NULL);
			_tmp17_ = _tmp16_;
			_tmp18_ = string_substring (_tmp17_, (glong) 0, (glong) 2);
			_g_free0 (symbol);
			symbol = _tmp18_;
			_g_free0 (_tmp17_);
			_g_free0 (_tmp15_);
		}
		_tmp19_ = symbol;
		_tmp20_ = g_strconcat ("[", _tmp19_, NULL);
		_tmp21_ = _tmp20_;
		_tmp22_ = g_strconcat (_tmp21_, "] ", NULL);
		_tmp23_ = _tmp22_;
		_g_free0 (_tmp21_);
		result = _tmp23_;
		_g_free0 (symbol);
		_g_object_unref0 (desc);
		return result;
	} else {
		gchar* _tmp24_;
		_tmp24_ = g_strdup ("[??] ");
		result = _tmp24_;
		_g_object_unref0 (desc);
		return result;
	}
	_g_object_unref0 (desc);
}


static void client_update_status (Client* self) {
	GString* _tmp0_;
	GString* builder;
	GString* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	FepGAttribute* attr;
	gboolean _tmp4_;
	gboolean _tmp68_ = FALSE;
	const gchar* _tmp69_;
	GString* _tmp70_;
	const gchar* _tmp71_;
	gboolean _tmp74_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_string_new ("");
	builder = _tmp0_;
	_tmp1_ = builder;
	_tmp2_ = client_format_indicator (self);
	_tmp3_ = _tmp2_;
	g_string_append (_tmp1_, _tmp3_);
	_g_free0 (_tmp3_);
	attr = NULL;
	_tmp4_ = self->priv->lookup_table_visible;
	if (_tmp4_) {
		IBusLookupTable* _tmp5_;
		guint _tmp6_;
		IBusLookupTable* _tmp7_;
		guint _tmp8_;
		guint pages;
		guint _tmp9_;
		IBusLookupTable* _tmp10_;
		guint _tmp11_;
		guint start;
		guint _tmp12_;
		IBusLookupTable* _tmp13_;
		guint _tmp14_;
		IBusLookupTable* _tmp15_;
		guint _tmp16_ = 0U;
		guint _tmp17_ = 0U;
		guint end;
		_tmp5_ = self->priv->lookup_table;
		_tmp6_ = _tmp5_->cursor_pos;
		_tmp7_ = self->priv->lookup_table;
		_tmp8_ = _tmp7_->page_size;
		pages = _tmp6_ / _tmp8_;
		_tmp9_ = pages;
		_tmp10_ = self->priv->lookup_table;
		_tmp11_ = _tmp10_->page_size;
		start = _tmp9_ * _tmp11_;
		_tmp12_ = start;
		_tmp13_ = self->priv->lookup_table;
		_tmp14_ = _tmp13_->page_size;
		_tmp15_ = self->priv->lookup_table;
		_tmp16_ = ibus_lookup_table_get_number_of_candidates (_tmp15_);
		_tmp17_ = MIN (_tmp12_ + _tmp14_, _tmp16_);
		end = _tmp17_;
		{
			guint _tmp18_;
			guint index;
			_tmp18_ = start;
			index = _tmp18_;
			{
				gboolean _tmp19_;
				_tmp19_ = TRUE;
				while (TRUE) {
					gboolean _tmp20_;
					guint _tmp22_;
					guint _tmp23_;
					IBusLookupTable* _tmp24_;
					guint _tmp25_;
					guint _tmp26_;
					IBusText* _tmp27_ = NULL;
					IBusText* _tmp28_;
					IBusText* label;
					IBusLookupTable* _tmp29_;
					guint _tmp30_;
					IBusText* _tmp31_ = NULL;
					IBusText* _tmp32_;
					IBusText* candidate;
					gchar* _tmp33_ = NULL;
					IBusText* _tmp34_;
					const gchar* _tmp41_;
					gchar* _tmp42_;
					gchar* label_text;
					const gchar* _tmp43_;
					IBusText* _tmp44_;
					const gchar* _tmp45_ = NULL;
					gchar* _tmp46_ = NULL;
					gchar* text;
					gboolean _tmp47_ = FALSE;
					IBusLookupTable* _tmp48_;
					gboolean _tmp49_ = FALSE;
					gboolean _tmp53_;
					GString* _tmp63_;
					const gchar* _tmp64_;
					guint _tmp65_;
					guint _tmp66_;
					_tmp20_ = _tmp19_;
					if (!_tmp20_) {
						guint _tmp21_;
						_tmp21_ = index;
						index = _tmp21_ + 1;
					}
					_tmp19_ = FALSE;
					_tmp22_ = index;
					_tmp23_ = end;
					if (!(_tmp22_ < _tmp23_)) {
						break;
					}
					_tmp24_ = self->priv->lookup_table;
					_tmp25_ = index;
					_tmp26_ = start;
					_tmp27_ = ibus_lookup_table_get_label (_tmp24_, _tmp25_ - _tmp26_);
					_tmp28_ = _g_object_ref0 (_tmp27_);
					label = _tmp28_;
					_tmp29_ = self->priv->lookup_table;
					_tmp30_ = index;
					_tmp31_ = ibus_lookup_table_get_candidate (_tmp29_, _tmp30_);
					_tmp32_ = _g_object_ref0 (_tmp31_);
					candidate = _tmp32_;
					_tmp34_ = label;
					if (_tmp34_ != NULL) {
						IBusText* _tmp35_;
						const gchar* _tmp36_ = NULL;
						gchar* _tmp37_;
						_tmp35_ = label;
						_tmp36_ = ibus_text_get_text (_tmp35_);
						_tmp37_ = g_strdup (_tmp36_);
						_g_free0 (_tmp33_);
						_tmp33_ = _tmp37_;
					} else {
						guint _tmp38_;
						guint _tmp39_;
						gchar* _tmp40_ = NULL;
						_tmp38_ = index;
						_tmp39_ = start;
						_tmp40_ = g_strdup_printf ("%u", (_tmp38_ - _tmp39_) + 1);
						_g_free0 (_tmp33_);
						_tmp33_ = _tmp40_;
					}
					_tmp41_ = _tmp33_;
					_tmp42_ = g_strdup (_tmp41_);
					label_text = _tmp42_;
					_tmp43_ = label_text;
					_tmp44_ = candidate;
					_tmp45_ = ibus_text_get_text (_tmp44_);
					_tmp46_ = g_strdup_printf ("%s:%s", _tmp43_, _tmp45_);
					text = _tmp46_;
					_tmp48_ = self->priv->lookup_table;
					_tmp49_ = ibus_lookup_table_is_cursor_visible (_tmp48_);
					if (_tmp49_) {
						guint _tmp50_;
						IBusLookupTable* _tmp51_;
						guint _tmp52_ = 0U;
						_tmp50_ = index;
						_tmp51_ = self->priv->lookup_table;
						_tmp52_ = ibus_lookup_table_get_cursor_pos (_tmp51_);
						_tmp47_ = _tmp50_ == _tmp52_;
					} else {
						_tmp47_ = FALSE;
					}
					_tmp53_ = _tmp47_;
					if (_tmp53_) {
						GString* _tmp54_;
						const gchar* _tmp55_;
						gint _tmp56_ = 0;
						gint start_index;
						gint _tmp57_;
						gint _tmp58_;
						const gchar* _tmp59_;
						gint _tmp60_ = 0;
						FepGAttribute _tmp61_ = {0};
						FepGAttribute* _tmp62_;
						_tmp54_ = builder;
						_tmp55_ = _tmp54_->str;
						_tmp56_ = g_utf8_strlen (_tmp55_, (gssize) (-1));
						start_index = _tmp56_;
						_tmp57_ = start_index;
						_tmp58_ = start_index;
						_tmp59_ = text;
						_tmp60_ = g_utf8_strlen (_tmp59_, (gssize) (-1));
						memset (&_tmp61_, 0, sizeof (FepGAttribute));
						_tmp61_.type = FEP_G_ATTR_TYPE_STANDOUT;
						_tmp61_.value = (guint) 1;
						_tmp61_.start_index = (guint) _tmp57_;
						_tmp61_.end_index = (guint) (_tmp58_ + _tmp60_);
						_tmp62_ = __fep_gattribute_dup0 (&_tmp61_);
						_g_free0 (attr);
						attr = _tmp62_;
					}
					_tmp63_ = builder;
					_tmp64_ = text;
					g_string_append (_tmp63_, _tmp64_);
					_tmp65_ = index;
					_tmp66_ = end;
					if (_tmp65_ < (_tmp66_ - 1)) {
						GString* _tmp67_;
						_tmp67_ = builder;
						g_string_append_c (_tmp67_, ' ');
					}
					_g_free0 (text);
					_g_free0 (label_text);
					_g_free0 (_tmp33_);
					_g_object_unref0 (candidate);
					_g_object_unref0 (label);
				}
			}
		}
	}
	_tmp69_ = self->priv->status;
	_tmp70_ = builder;
	_tmp71_ = _tmp70_->str;
	if (g_strcmp0 (_tmp69_, _tmp71_) != 0) {
		_tmp68_ = TRUE;
	} else {
		FepGAttribute* _tmp72_;
		FepGAttribute* _tmp73_;
		_tmp72_ = self->priv->status_attr;
		_tmp73_ = attr;
		_tmp68_ = _fep_gattribute_equal (_tmp72_, _tmp73_) != TRUE;
	}
	_tmp74_ = _tmp68_;
	if (_tmp74_) {
		GString* _tmp75_;
		const gchar* _tmp76_;
		FepGAttribute* _tmp77_;
		GString* _tmp78_;
		const gchar* _tmp79_;
		gchar* _tmp80_;
		FepGAttribute* _tmp81_;
		FepGAttribute* _tmp82_;
		_tmp75_ = builder;
		_tmp76_ = _tmp75_->str;
		_tmp77_ = attr;
		fep_g_client_set_status_text ((FepGClient*) self, _tmp76_, _tmp77_);
		_tmp78_ = builder;
		_tmp79_ = _tmp78_->str;
		_tmp80_ = g_strdup (_tmp79_);
		_g_free0 (self->priv->status);
		self->priv->status = _tmp80_;
		_tmp81_ = attr;
		_tmp82_ = __fep_gattribute_dup0 (_tmp81_);
		_g_free0 (self->priv->status_attr);
		self->priv->status_attr = _tmp82_;
	}
	_g_free0 (attr);
	_g_string_free0 (builder);
}


static void _client_ibus_show_lookup_table (Client* self) {
	g_return_if_fail (self != NULL);
	self->priv->lookup_table_visible = TRUE;
	client_update_status (self);
}


static void _client_ibus_hide_lookup_table (Client* self) {
	gboolean _tmp0_ = FALSE;
	Options _tmp1_;
	PreeditStyle _tmp2_;
	gboolean _tmp4_;
	g_return_if_fail (self != NULL);
	self->priv->lookup_table_visible = FALSE;
	_tmp1_ = self->priv->opts;
	_tmp2_ = _tmp1_.preedit_style;
	if (_tmp2_ == PREEDIT_STYLE_ROOT) {
		gboolean _tmp3_;
		_tmp3_ = self->priv->preedit_visible;
		_tmp0_ = _tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp4_ = _tmp0_;
	if (_tmp4_) {
		_client_ibus_show_preedit_text (self);
	} else {
		client_update_status (self);
	}
}


static void _client_ibus_update_lookup_table (Client* self, IBusLookupTable* lookup_table, gboolean visible) {
	IBusLookupTable* _tmp0_;
	IBusLookupTable* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (lookup_table != NULL);
	_tmp0_ = lookup_table;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->lookup_table);
	self->priv->lookup_table = _tmp1_;
	_tmp2_ = visible;
	if (_tmp2_) {
		_client_ibus_show_lookup_table (self);
	} else {
		_client_ibus_hide_lookup_table (self);
	}
}


static void _client_ibus_global_engine_changed (Client* self, const gchar* name) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	client_update_status (self);
}


static gboolean client_real_filter_key_event (FepGClient* base, guint keyval, guint modifiers) {
	Client * self;
	gboolean result = FALSE;
	IBusInputContext* _tmp0_;
	self = (Client*) base;
	_tmp0_ = self->priv->context;
	if (_tmp0_ != NULL) {
		IBusInputContext* _tmp1_;
		guint _tmp2_;
		guint _tmp3_;
		gboolean _tmp4_ = FALSE;
		gboolean retval;
		gboolean _tmp5_;
		_tmp1_ = self->priv->context;
		_tmp2_ = keyval;
		_tmp3_ = modifiers;
		_tmp4_ = ibus_input_context_process_key_event (_tmp1_, (guint32) _tmp2_, (guint32) 0, (guint32) _tmp3_);
		retval = _tmp4_;
		_tmp5_ = retval;
		if (_tmp5_) {
			client_update_status (self);
		}
		result = retval;
		return result;
	}
	result = FALSE;
	return result;
}


static gboolean client_watch_func (Client* self, GIOChannel* source, GIOCondition condition) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (source != NULL, FALSE);
	fep_g_client_dispatch ((FepGClient*) self);
	result = TRUE;
	return result;
}


static void __client_ibus_commit_text_ibus_input_context_commit_text (IBusInputContext* _sender, IBusText* p0, gpointer self) {
	_client_ibus_commit_text (self, p0);
}


static void __client_ibus_show_preedit_text_ibus_input_context_show_preedit_text (IBusInputContext* _sender, gpointer self) {
	_client_ibus_show_preedit_text (self);
}


static void __client_ibus_hide_preedit_text_ibus_input_context_hide_preedit_text (IBusInputContext* _sender, gpointer self) {
	_client_ibus_hide_preedit_text (self);
}


static void __client_ibus_update_preedit_text_ibus_input_context_update_preedit_text (IBusInputContext* _sender, IBusText* p0, guint p1, gboolean p2, gpointer self) {
	_client_ibus_update_preedit_text (self, p0, p1, p2);
}


static void __client_ibus_show_lookup_table_ibus_input_context_show_lookup_table (IBusInputContext* _sender, gpointer self) {
	_client_ibus_show_lookup_table (self);
}


static void __client_ibus_hide_lookup_table_ibus_input_context_hide_lookup_table (IBusInputContext* _sender, gpointer self) {
	_client_ibus_hide_lookup_table (self);
}


static void __client_ibus_update_lookup_table_ibus_input_context_update_lookup_table (IBusInputContext* _sender, IBusLookupTable* p0, gboolean p1, gpointer self) {
	_client_ibus_update_lookup_table (self, p0, p1);
}


static void client_create_input_context_done (Client* self) {
	IBusInputContext* _tmp0_;
	IBusInputContext* _tmp1_;
	IBusInputContext* _tmp2_;
	IBusInputContext* _tmp3_;
	IBusInputContext* _tmp4_;
	IBusInputContext* _tmp5_;
	IBusInputContext* _tmp6_;
	IBusInputContext* _tmp7_;
	IBusInputContext* _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->context;
	g_signal_connect_object (_tmp0_, "commit-text", (GCallback) __client_ibus_commit_text_ibus_input_context_commit_text, self, 0);
	_tmp1_ = self->priv->context;
	g_signal_connect_object (_tmp1_, "show-preedit-text", (GCallback) __client_ibus_show_preedit_text_ibus_input_context_show_preedit_text, self, 0);
	_tmp2_ = self->priv->context;
	g_signal_connect_object (_tmp2_, "hide-preedit-text", (GCallback) __client_ibus_hide_preedit_text_ibus_input_context_hide_preedit_text, self, 0);
	_tmp3_ = self->priv->context;
	g_signal_connect_object (_tmp3_, "update-preedit-text", (GCallback) __client_ibus_update_preedit_text_ibus_input_context_update_preedit_text, self, 0);
	_tmp4_ = self->priv->context;
	g_signal_connect_object (_tmp4_, "show-lookup-table", (GCallback) __client_ibus_show_lookup_table_ibus_input_context_show_lookup_table, self, 0);
	_tmp5_ = self->priv->context;
	g_signal_connect_object (_tmp5_, "hide-lookup-table", (GCallback) __client_ibus_hide_lookup_table_ibus_input_context_hide_lookup_table, self, 0);
	_tmp6_ = self->priv->context;
	g_signal_connect_object (_tmp6_, "update-lookup-table", (GCallback) __client_ibus_update_lookup_table_ibus_input_context_update_lookup_table, self, 0);
	_tmp7_ = self->priv->context;
	ibus_input_context_set_capabilities (_tmp7_, (guint32) (((IBUS_CAP_PREEDIT_TEXT | IBUS_CAP_LOOKUP_TABLE) | IBUS_CAP_AUXILIARY_TEXT) | IBUS_CAP_FOCUS));
	_tmp8_ = self->priv->context;
	ibus_input_context_focus_in (_tmp8_);
	client_update_status (self);
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		Client * self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->bus);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}


static void __client_ibus_global_engine_changed_ibus_bus_global_engine_changed (IBusBus* _sender, const gchar* p0, gpointer self) {
	_client_ibus_global_engine_changed (self, p0);
}


static void __lambda2_ (Block1Data* _data1_, GObject* obj, GAsyncResult* res) {
	Client * self;
	GError * _inner_error_ = NULL;
	self = _data1_->self;
	g_return_if_fail (res != NULL);
	{
		IBusBus* _tmp0_;
		GAsyncResult* _tmp1_;
		IBusInputContext* _tmp2_ = NULL;
		IBusInputContext* _tmp3_;
		IBusInputContext* _tmp4_;
		_tmp0_ = _data1_->bus;
		_tmp1_ = res;
		_tmp2_ = ibus_bus_create_input_context_async_finish (_tmp0_, _tmp1_, &_inner_error_);
		_tmp3_ = _tmp2_;
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
		}
		_tmp4_ = _g_object_ref0 (_tmp3_);
		_g_object_unref0 (self->priv->context);
		self->priv->context = _tmp4_;
		client_create_input_context_done (self);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		g_warning ("client.vala:263: can't create input context: %s", _tmp6_);
		_g_error_free0 (e);
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void ___lambda2__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
	__lambda2_ (self, source_object, res);
	block1_data_unref (self);
}


static gboolean _client_watch_func_gio_func (GIOChannel* source, GIOCondition condition, gpointer self) {
	gboolean result;
	result = client_watch_func (self, source, condition);
	return result;
}


Client* client_construct (GType object_type, IBusBus* bus, Options* opts, GError** error) {
	Client * self = NULL;
	Block1Data* _data1_;
	IBusBus* _tmp0_;
	IBusBus* _tmp1_;
	Options _tmp2_;
	IBusBus* _tmp3_;
	IBusBus* _tmp4_;
	gint _tmp5_ = 0;
	GIOChannel* _tmp6_;
	GIOChannel* channel;
	GIOChannel* _tmp7_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (bus != NULL, NULL);
	g_return_val_if_fail (opts != NULL, NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_tmp0_ = bus;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_data1_->bus = _tmp1_;
	self = (Client*) g_object_new (object_type, "address", NULL, NULL);
	_data1_->self = g_object_ref (self);
	g_initable_init ((GInitable*) self, NULL, &_inner_error_);
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		block1_data_unref (_data1_);
		_data1_ = NULL;
		_g_object_unref0 (self);
		return NULL;
	}
	_tmp2_ = *opts;
	self->priv->opts = _tmp2_;
	_tmp3_ = _data1_->bus;
	g_signal_connect_object (_tmp3_, "global-engine-changed", (GCallback) __client_ibus_global_engine_changed_ibus_bus_global_engine_changed, self, 0);
	_tmp4_ = _data1_->bus;
	ibus_bus_create_input_context_async (_tmp4_, "ibus-fep", -1, NULL, ___lambda2__gasync_ready_callback, block1_data_ref (_data1_));
	_tmp5_ = fep_g_client_get_poll_fd ((FepGClient*) self);
	_tmp6_ = g_io_channel_unix_new (_tmp5_);
	channel = _tmp6_;
	_tmp7_ = channel;
	g_io_add_watch (_tmp7_, G_IO_IN, _client_watch_func_gio_func, self);
	_g_io_channel_unref0 (channel);
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return self;
}


Client* client_new (IBusBus* bus, Options* opts, GError** error) {
	return client_construct (TYPE_CLIENT, bus, opts, error);
}


static void client_class_init (ClientClass * klass) {
	client_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ClientPrivate));
	FEP_G_CLIENT_CLASS (klass)->filter_key_event = client_real_filter_key_event;
	G_OBJECT_CLASS (klass)->finalize = client_finalize;
}


static void client_instance_init (Client * self) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	self->priv = CLIENT_GET_PRIVATE (self);
	self->priv->context = NULL;
	self->priv->preedit_visible = FALSE;
	self->priv->lookup_table_visible = FALSE;
	_tmp0_ = g_strdup ("");
	self->priv->preedit = _tmp0_;
	_tmp1_ = g_strdup ("");
	self->priv->status = _tmp1_;
}


static void client_finalize (GObject* obj) {
	Client * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CLIENT, Client);
	_g_object_unref0 (self->priv->context);
	_g_object_unref0 (self->priv->lookup_table);
	_g_free0 (self->priv->preedit);
	_g_free0 (self->priv->preedit_attr);
	_g_free0 (self->priv->status);
	_g_free0 (self->priv->status_attr);
	G_OBJECT_CLASS (client_parent_class)->finalize (obj);
}


GType client_get_type (void) {
	static volatile gsize client_type_id__volatile = 0;
	if (g_once_init_enter (&client_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ClientClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) client_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Client), 0, (GInstanceInitFunc) client_instance_init, NULL };
		GType client_type_id;
		client_type_id = g_type_register_static (fep_g_client_get_type (), "Client", &g_define_type_info, 0);
		g_once_init_leave (&client_type_id__volatile, client_type_id);
	}
	return client_type_id__volatile;
}



